#ifndef _CONVEX_HULL_2D_
#define _CONVEX_HULL_2D_

#include <iostream>
#include <vector>
#include "gmtl/gmtl.h"

class Convexhull2D {
	public:	
		friend int indexcompare(const void* a, const void* b);
		friend struct VectorindexCompare;
				
		Convexhull2D(gmtl::Vec2f* a, size_t n);
		Convexhull2D();
		Convexhull2D(const Convexhull2D&);
		~Convexhull2D();
		
		void construct(gmtl::Vec2f* points, size_t n);
		
		size_t size() const;		

		std::vector<gmtl::Vec2f> vertices;
	private:
		class Vectorindex {			
			public:
				Vectorindex() : flag(true) {};
				gmtl::Vec2f pv;
				size_t i;
				bool flag;
				Vectorindex* pi;
		};					
		int iSize;
};

float area(std::vector<gmtl::Vec2f>& v); // area of convex polygon define by contour v


inline size_t Convexhull2D::size() const {
	return iSize;
};

#endif //_CONVEX_HULL_2D_
