#ifndef __LINE_2D__
#define __LINE_2D__

#include <vector>
#include "gmtl/gmtl.h"

class Line2D {
	public:
		friend bool intersect(gmtl::Vec2f& i, const Line2D& l1, const Line2D& l2);
		Line2D(const gmtl::Vec2f& a, const gmtl::Vec2f& b) {this->a = a; this->b = b;}
		Line2D ortho();
		Line2D parallel(gmtl::Vec2f& q);
		gmtl::Vec2f maxPointToLine(std::vector<gmtl::Vec2f>& v);
		float distpoint(gmtl::Vec2f& p) const;
		gmtl::Vec2f& getA() {return a;}
		gmtl::Vec2f& getB() {return b;}
	private:
		gmtl::Vec2f a;
		gmtl::Vec2f b;
};

bool intersect(gmtl::Vec2f& i, const Line2D& l1, const Line2D& l2);

#endif //__LINE_2D__
